#!/bin/sh

LOCK=/tmp/ism_chemanalyzer.lock

perr(){
    echo >2 $1 
}

install_ismpy(){
    cat << EOF

We recommend to install a dedicated python environment suitable for all the
ISM tools, as described in the README file.

EOF
}

if [ ! -d $HOME/.ismpy ]; then
    perr "Error, a proper python environment seems not to be installed on your system."
    install_ismpy
    exit 1
fi


mkdir $LOCK 2>/dev/null
if [ $? -ne 0 ]; then
    cat << EOF

It seems that another instance of the chemistry analyszer is already running.
If so, please close it and retry.

If not, it possible that the lock file got lost during an other run. You have
to manually remove it:

    rm -rf $LOCK

Then retry.

EOF
    exit 1
fi

trap "rm -rf ${LOCK}; exit" INT TERM EXIT

cat << EOF

To access the Chemistry Analyzer application, just open the
'visualiser/index.html' file in your favorite web browser.

Press ctrl-C to close the server

EOF

2>/dev/null $HOME/.ismpy/bin/python server/server.py 

rm -rf ${LOCK}

