idat
====


*idat* is a swissknife tool to process and analyse ISM data produced by the
ISM Services Plateform (http://ism.obspm.fr).

Browsing and searching for ISM data is done through ISMDB
(http://ismdb.obspm.fr)


Quickstart
----------

Once the tool is properly setup (see Install), you can start using it with

    <where you put the idat project>/idat

This will start the main gui.


### Commands

*idat* allows for various processing on ISM data through *command*s:

    idat <command> [options...]

Help on each `<command>` can be obtained with

    idat <command> -h

`<command>` can be

    dataanalysis
    da
                        It starts the data analysis web user interface.

    plot
    p
                        This command builds customizable plot files (img, pdf) from ISM data file

    extract
    e
                        This command extracts user defined quantities from an ISM
                        raw data file and exports them in a ascii file for further processing.




Install
-------

### requirements

- sqlite3 (+dev package)
- hdf5 (+dev package)
- yaml
- python >3.4 (+dev package)
- all the non python dependencies of numpy and matplotlib (ex: lapack, ...)
- modern webbrowser to use the data analysis web ui (internet explorer not supported!)


### The ISM python environment

A proper Python environment able to run *idat* and all the ISM python
softwares can be easily installed with the command `idat install`. 

    idat install

The command will take care of installing all the Python dependencies required.
Once installed this way, the `python` program to run the ISM softwares will be
located at:

    ~/.ismpy/bin/python3

It may be useful to define an alias for this python environement, for example
in the user `~/.bashrc` or `~/.profile` file:

    alias ismpy="~/.ismpy/bin/python3"

Then, one would just call `ismpy` from the terminal to run the ismpy python
environment.


#### uninstall the ISM python environment

To uninstall the ISM python environment (for example before reinstalling from
scratch a clean environment)

    idat deinstall

