#!/usr/bin/env python3

import argparse
import subprocess
import os
import sys

parser = argparse.ArgumentParser(prog="idat da|dataanalysis")
parser.add_argument("--server",
                    help="run server only (advanced users only)", 
                    action='store_const', const='--server')
args = vars(parser.parse_args())


module_home = os.getenv("MODULE_HOME")
cmd = ['/bin/sh', module_home + "/start.sh"]

from server.lib import config as mconf
uri = "http://{}:{}{}/ui/import".format(mconf.SERVER_HOST,
        mconf.SERVER_PORT,
        mconf.BASE_URL)
cmdargs = [uri]

cmdargs += list(filter(None, [args['server']]))

# start web server
proc = subprocess.Popen(cmd + cmdargs, 
        bufsize = 0, 
        stderr = subprocess.STDOUT)

try :
    proc.wait()
except KeyboardInterrupt as e:
    print(" Leaving Idat.")
except Exception as e:
    print("An error occurred")
    print(e)
