#!/usr/bin/env python3

import argparse
import subprocess
import os
import sys


parser = argparse.ArgumentParser(prog="idat e|extract")
parser.add_argument("h5file",
                    help="path towards the HDF5 file")
parser.add_argument("template",
                    help="path towards the ASCII file with the list \
                         of quantities to extract")
parser.add_argument("output",
                    help="path of the generated ASCII file")

args = vars(parser.parse_args())

idat_home = os.getenv("IDAT_HOME")
cmd = [
        sys.executable, 
        idat_home + "/modules/idat-plot/src/idatplot/extract/extract.py"]

cmdargs = ['-t']
cmdargs += list(filter(None, 
    [args['h5file'], args['template'], args['output']]))

subprocess.Popen(cmd + cmdargs, bufsize = 0).wait()
