Use pdrpostprocs libs in python projects
=========================================

Quickstart
------------

    from pdrpostprocs.plot import plot as ppp
    from pdrpostprocs.lib import utils as pu 

    outdir = "/home/toto/plots"
    _qid = pu.qid

    cf = dict(pu.load_conf(cffile))
    quantities = set([_qid(q) for pcf in cf['plot'] for q in _q(pcf)])

    # data = ppp.parse_data(datafile, filters = quantities)
    # from now, the data is considered quite clean (cleaning done in parse_data) 
    # This means, for example, that not existing/invalid quantities are
    # discarded, i.e are not in the `data` object.
    
    # the `data` adt as built by `parse_data` (from an extractor prduced txt
    # file) is (header, unit, data)

    runid = "toto"

    for fig, ax, of in ppp.make_plots(cf, runid, data):
        of = of + '.png' if not of else of.format(runid)
        plot_path = outdir + '/' + of
        print("writing {}".format(plot_path))
        with open(plot_path, 'wb') as of:
            of.write(to_bytes(fig).getvalue())
 

### Data format

The data ADT is loaded from a txt file as produced by the extractor module.

### Plot config

The plot config is selfdocumented in the example .yaml files in `plot/conf`.


