# Physical constant

k_B = 1.3807E-16    # cgs
h   = 6.6261E-27    # cgs
c   = 2.99792458E10 # cgs

cm_to_microns = 1E4

JWST_min = 0.6 # microns
JWST_max = 28.8 # microns
c1 = 0
c2 = 0
c3 = 0
file = open("line_h2.dat",'r')
file2 = open("quantity_list_H2.txt",'w')
file3 = open("linelist_H2.txt",'w')
file.readline()
file.readline()
file.readline()
file.readline()
for line in file :
    if line[0] != '#' :
        c1+=1
        T = float(line.split()[3])
        E = k_B*T
        nu = E/h
        wl = c/nu
        wl *= cm_to_microns
        if wl >= JWST_min and wl <= JWST_max :
            c2+=1
            # get quantum numbers
            qnums = list(map(int,line.split(":")[1].split(";")[:4]))
            transition_name = "H2 v=%i,J=%i->v=%i,J=%i"%(qnums[0],qnums[1],qnums[2],qnums[3])
            intensity_string = "I(H2 v=%i,J=%i->v=%i,J=%i angle 00 deg)"%(qnums[0],qnums[1],qnums[2],qnums[3])
            conrib_string = "Contribution to intensities(H2 v=%i,J=%i->v=%i,J=%i)"%(qnums[0],qnums[1],qnums[2],qnums[3])
            escapprob_string = "Escape probability observer side(H2 v=%i,J=%i->v=%i,J=%i)"%(qnums[0],qnums[1],qnums[2],qnums[3])
            optdepth_string = "Line optical depth observer side(H2 v=%i,J=%i->v=%i,J=%i)"%(qnums[0],qnums[1],qnums[2],qnums[3])
            locemiss_string = "Emissivity(H2 v=%i,J=%i->v=%i,J=%i)"%(qnums[0],qnums[1],qnums[2],qnums[3])
            file2.write(intensity_string+"\n"+conrib_string+"\n"+escapprob_string+"\n"+optdepth_string+"\n"+locemiss_string+"\n")
            print(wl,intensity_string)
            file3.write("%5f    "%(wl)+transition_name+"\n")
            c3+=4
            
print("%i lines read, %i lines kept, %i quantities written to file."%(c1,c2,c3))
file.close()
file2.close()
file3.close()
