# installation directory

def _stripe_dirn(p, offset):
    if offset == 0:
        return p
    return _stripe_dirn(os.path.dirname(p), offset - 1)

BASE_DIRECTORY = None

if not BASE_DIRECTORY:
    import os
    BASE_DIRECTORY = _stripe_dirn(os.path.realpath(__file__), 4)
    print("auto computed base directory: {}".format(BASE_DIRECTORY))



ISM_WEBSITE="https://ism.obspm.fr"
# SERVICE_URI="https://app.ism.obspm.fr/ismdb-idat"
SERVICE_URI="http://localhost:5000"
ALLOWED_CODES = ['pdr', 'shock']
IDAT_DIRECTORY=_stripe_dirn(BASE_DIRECTORY, 2)
# not to be edited
BASE_URL = ""
CLEAN_USERDATA = True
CLEAN_OUTPUT = True
CLIENT_DIRECTORY = "{}/src/client".format(BASE_DIRECTORY)
SERVER_DIRECTORY = "{}/src/server".format(BASE_DIRECTORY)
DATA_DIRECTORY = "{}/userdata/hdf5".format(IDAT_DIRECTORY)
TEMPLATE_DIRECTORY = "{}/modules/ism-dataanalysis/src/server/lib/templates".format(IDAT_DIRECTORY)
OUTPUT_DIRECTORY = "{}/userdata/output".format(IDAT_DIRECTORY)
TASKS_OUTPUT_DIRECTORY = "{}/tasks".format(SERVER_DIRECTORY)
ISMVOCA_DICTS_DIRECTORY = "{}/material/dictionaries".format(BASE_DIRECTORY)
ISMVOCA_DICTS = {'pdr': 'pdr.sqlite', 'shock': 'shock.sqlite'}
# for use on online version
# ISMVOCA_DICTS = {'pdr': 'pdr-with-syn.sqlite', 'shock': 'shock.sqlite'}
YAML_TEMPLATE_NAME = "idat_plot_template.yaml"

JOBS_DB = "{}/jobs.db".format(SERVER_DIRECTORY)

# time in seconds for which the script will wait to check for new jobs
JOB_CHECK_INTERVAL = 1

# time in seconds before purging generated files and database 
# ( session, completed / failed jobs )
DATA_PRESERVATION_DURATION = 86400
# time in seconds before data are purged from server cache
CACHE_LIFETIME = 3600
SERVER_HOST = 'localhost'
SERVER_PORT = 5000
PAGE_OPENING_TEMPO = 2

# hdf file authorized extensions
ALLOWED_EXTENSIONS = set(['hdf5', 'h5'])

# number of suggested results for quantities autocomplete
SUGGEST_RESULT_LIMIT = 15

# possible values are :  local, web
SERVER_MODE='local'
