<%
css = "\n".join([
    '<link rel="stylesheet" href="static/css/commons/pure.css"/>',
    '<link rel="stylesheet" href="static/css/commons/grids-responsive.css"/>',
    '<link rel="stylesheet" href="static/css/commons/utils.css">',
    '<link rel="stylesheet" href="static/css/commons/style-ism-light.css"  />',
    '<link rel="stylesheet" href="static/css/commons/apps.css">',
    '<link rel="stylesheet" href="static/css/2.27_dist_skin-win8_ui.fancytree.min.css" >',   
    '<link rel="stylesheet" href="static/css/auto-complete.css">',
    '<link rel="stylesheet" href="static/css/idat.css">'
])
include('header.tpl', css_links = css)
%>

<div class="content">
  <div id="nav-line" class="nav-line">
    <div class="flexr h1_1">
      <div class="w2_3" id="nav-links">
      </div>
      <div id="nav-help" class="w1_3 flexr flex1end h1_1">
      <div class="center">
        <div class="tag">
          <a href="{{service_uri}}/ui/help">Help</a>
        </div>
      </div>

      </div>
    </div>
  </div>    

  <div id="loading" class="loading">
    <img src="static/img/spinner.gif" alt="loading"/>
  </div>    

  <div class="pure-g">
    <div class="pure-u-10-24 content-header">
      <h2><span>IDAT:</span><span class="lighter-text"> Data analysis</span></h2>
      <h4><span id="page_type"></span></h4>
      <div id="filename" class="filename"></div>          
    </div>
    <div class="pure-u-14-24">
      <div class="infobox">
        <p>
        This tool allows to <strong>extract data</strong> produced by 
        the ISM platform codes (as text files) and 
        to <strong>plot the results</strong>.
        </p>
        <ul>
          <li>
            Search among the computed quantities with the search
            bar or in the data tree listing all available quantities.
          </li>
          <li>
            The quantities you select will appear 
            in the boxes of section 2.
          </li>
          <li>
            If you already know the quantity names, you can 
            also directly type or paste them into the boxes.
          </li>
          <li>
            Export as text files or plot the data with 
            our interactive plot tool using the corresponding buttons.
          </li>
        </ul>
      </div>  
    </div>
    <div class="pure-u-24-24">
      <h3 class="divider">1. Select quantities to extract or plot</h3> 
    </div>    
    <div class="pure-u-24-24">                
      <div class="searchbar-area">  
        <div></div>         
        <div id="searchbar_container" class="gui-area">
          <input type="text" 
                 id="searchbar" 
                 required 
                 autofocus 
                 aria-autocomplete="list" 
                 placeholder="Find quantities computed by the code with the search bar"/>      
        </div>
      </div>
    </div>
    <div class="pure-u-8-24">
      <div class="tree-area">
        <div>Find quantities in the data tree</div>      
        <div id="tree_container" class="gui-area tree-container"></div>
      </div>
    </div>
    <div class="pure-u-15-24">
      <div>
        <div class="tags" id="tags"></div>
        <div class="pure-g tags-reset">
          <div class="pure-u-12-24 left">
            <a href="#user_integrated_selection_error">
              Next step >>
            </a>                  
          </div>
          <div class="pure-u-12-24 right">
            <a id="clear_tag_buttons" href="#">
              Clear all selection
            </a>          
          </div>
        </div>
      </div>              
    </div>
  </div>

  <div class="pure-g content">
    <div class="gui-area pure-u-24-24">                
      <h3 class="divider">2. List of selected quantities</h3>
    </div>
    <div class="gui-area pure-u-12-24">          
      <p>      
      Extract the chosen quantities as datafiles or 
      plot them with our interactive plot tool.
      </p>
      <p>
      Direct cut/paste into this box is possible. You can also manually
      add and delete quantities.
      </p>
    </div>
    <div class="gui-area pure-u-12-24">
      <div class="infobox">
        <p>
        The selected quantities are divided between local quantities 
        (functions of the position) on the left, and global quantities 
        (taking one single value for the whole model) such as 
        integrated quantities and model parameters on the right.
        </p>
      </div>
    </div>  
    <div class="pure-u-11-24">
      <div class="pure-g">              
        <div class="gui-area pure-u-15-24">                    
          <h4 class='divider'>Local quantities (position dependant)</h4>
          <textarea rows='7' id="user_local_selection"></textarea>
          <p id="user_local_selection_error"></p>
        </div>
        <div class="pure-u-7-24 actions">
          <h4 class='divider'>Actions</h4>
          <div  class="gui-area">
            <button id='local_data_text_button' class='btn btn-primary gui-button--large'>Export as ASCII file</button>
            <button id='local_data_votable_button' class='btn btn-primary gui-button--large'>Export as VOTable</button>
            <button id='local_data_gotoplot_button' class='btn btn-primary gui-button--large gui-button--plot'>Plot</button>
            <div id='local_data_status' class="extract-status"></div>
          </div>
        </div>
      </div>  
    </div>
    <div class="pure-u-11-24">
      <div class="pure-g">
        <div class="gui-area pure-u-15-24 integrated-quantities">
          <h4 class='divider'>Integrated quantities or parameters</h4>
          <textarea rows='7' id="user_integrated_selection"></textarea>
          <p id="user_integrated_selection_error"></p>
        </div>
        <div class="pure-u-7-24 actions">
          <h4 class='divider'>Actions</h4>
          <div class="gui-area">
            <button id='integrated_data_text_button' class='btn btn-primary gui-button--large'>Export as ASCII file</button>
            <button id='integrated_data_votable_button' class='btn btn-primary gui-button--large'>Export as VOTable</button>
            <div id='integrated_data_status' class="extract-status"></div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="pure-g content">
    <div class="pure-u-1 plot-container hidden" id="plot_container">
      <div class="pure-g">
        <div class="gui-area pure-u-1">
          <h3 class="divider">3. Plot selected quantities</h3>
        </div>

        <div class="gui-area pure-u-11-24">
          <div id="plot_gui" >                        
            <div id="x_plot_area" class="x-plot-area"></div>
            <div id="y1_plot_area"></div>
            <div id="y2_plot_area"></div>
            <button id='plot_data_button' class='btn btn-primary gui-button--large gui-button--plot'>Plot</button>
          </div>            
        </div>
        <div class="pure-u-1-24">&nbsp;</div>
        <div class="gui-area pure-u-12-24 flexc flex1center flex2center">
          <div id="plot_result" class="plot-result"></div>
        </div>        
      </div>
    </div>
  </div>
</div>

<!-- Required Javascript -->  
<script src="static/js/auto-complete.js"></script>
<script src="static/js/jquery-3.4.1.min.js"></script>
<script src="static/js/jquery.fancytree-all-deps.min.js"></script>
<script src="static/js/jquery.fancytree.multi.js"></script>
<script src="static/js/tags.js"></script>
<script src="static/js/selection.min.js"></script>
<script src="static/js/config.js"></script>
<script src="static/js/script.js"></script>


% include('footer.tpl')


