# -*- coding: utf-8 -*-
import os
import os.path
from . import config as cfg
from pathlib import Path

def create_file_link(filepath):
    #fileparts = filepath.split("/")
    filename = os.path.basename(filepath) #fileparts[len(fileparts) - 1]
    try:
        os.symlink(filepath, os.path.join(cfg.DATA_DIRECTORY, filename))
    except OSError:
        path = os.path.join(cfg.DATA_DIRECTORY, filename)
        if os.path.islink(path):
            if Path(path).resolve() != Path(filepath).resolve():
                os.remove(os.path.join(cfg.DATA_DIRECTORY, filename))
                os.symlink(filepath, os.path.join(cfg.DATA_DIRECTORY, filename))

class ScriptReader(object):
  @staticmethod
  def getColumns(filename):
    f = open(filename)
    result = []
    for value in f.readlines():
      result.append(value.strip())
    f.close()
    return result  
        
  @staticmethod
  def getHeader(filename):
    precision = cfg.floatPrecision
    f = open(filename)
    result = []
    for value in f.readlines():
        if value[0] == '#':
          if '#precision:' in value:
            tmp =  value.split(':')[1].strip()
            if tmp == cfg.doublePrecision :
              precision = tmp
          else:
            result.append(value)
    f.close()
    if len(result) == 0:
      return precision, None
    return precision, result  
